       IDENTIFICATION DIVISION.
       PROGRAM-ID. VSPS730.
      *
      **** rel 7.2
      * NUOVO
      ************
       ENVIRONMENT DIVISION.
       CONFIGURATION SECTION.
       SPECIAL-NAMES. DECIMAL-POINT IS COMMA.
       INPUT-OUTPUT SECTION.
       FILE-CONTROL.
           COPY 'griazisl'.
           COPY 'griaazsl'.
           COPY 'grispssl'.
           COPY 'grispdsl'.
           COPY 'grisstsl'.
           COPY 'gritabsl'.
           COPY 'griclfsl'.
           COPY 'griacfsl'.
           COPY 'gribktsl'.
           SELECT WDSLAV ASSIGN TO DISK
                  ORGANIZATION INDEXED
                  LOCK MANUAL WITH LOCK ON MULTIPLE RECORDS
                  ACCESS DYNAMIC RECORD KEY KEYLV STATUS SF-LAV.
       DATA DIVISION.
       FILE SECTION.
           COPY 'griazi'.
           COPY 'griaaz'.
           COPY 'grisps'.
           COPY 'grispd'.
           COPY 'grisst'.
           COPY 'gritab'.
           COPY 'griclf'.
           COPY 'griacf'.
           COPY 'gribkt'.
       FD  WDSLAV LABEL RECORD STANDARD
           VALUE OF FILE-ID ID-LAV
           RECORD 35 DATA RECORD RF-LAV.
       01  RF-LAV.
           02 KEYLV.
             05 KLV-AZI   PIC 9(3).
             05 KLV-ANNO  PIC 9(4).
             05 KLV-COD.
                10 KLV-MAS   PIC 9(2).
                10 KLV-CD    PIC 9(5).
             05 KLV-KEYSPD PIC X(21).
       WORKING-STORAGE SECTION.
           COPY 'grirel-72'.
           COPY 'gritabrk'.
           COPY 'griazirk'.
           COPY 'grij02rk'.
           COPY 'griclfrk'.
           COPY 'gribktrk'.
           COPY 'parzf'.
           COPY 'parcdt'.
           COPY 'parwxml-2-72'.
           COPY 'parmb'.
           COPY 'parul'.
           COPY 'prfisc'.
           COPY 'prpiva'.
           COPY 'pardsps'.
       01  ID-AZI PIC X(15) VALUE 'anaazi'.
       01  ID-AAZ PIC X(15) VALUE 'appazi'.
       01  ID-SPS PIC X(15) VALUE 'spesog'.
       01  ID-SPD PIC X(15) VALUE 'spedoc'.
       01  ID-SST PIC X(15) VALUE 'spetab'.
       01  ID-TAB PIC X(15) VALUE 'tabell'.
       01  ID-CLF PIC X(15) VALUE 'anaclf'.
       01  ID-ACF PIC X(15) VALUE 'appclf'.
       01  ID-LAV PIC X(15) VALUE 'wdslav'.
       01  ID-BKT PIC X(15) VALUE 'blktab'.
       01  COMODI.
           05 SF-AZI  PIC XX.
           05 SF-AAZ  PIC XX.
           05 SF-SPS  PIC XX.
           05 SF-SPD  PIC XX.
           05 SF-SST  PIC XX.
           05 SF-TAB  PIC XX.
           05 SF-CLF  PIC XX.
           05 SF-ACF  PIC XX.
           05 SF-LAV  PIC XX.
           05 SF-BKT  PIC XX.
           05 MESS     PIC X(40) VALUE SPACE.
           05 SWINI    PIC 9     VALUE ZERO.
           05 FUN-PREC PIC X     VALUE ZERO.
           05 VFLD     PIC 9.
           05 FUN      PIC X.
           05 CAMPO    PIC X(20).
           05 VCAMPO   PIC X(20).
           05 PIVA     PIC 9(11) VALUE ZERO.
           05 PKDT1    PIC 9(5).
           05 PKDT2    PIC 9(5).
           05 AA1      PIC 9(5).
           05 AA2      PIC 9(5).
           05 MM1      PIC 9(5).
           05 MM2      PIC 9(5).
           05 COMNUM   PIC 9(10)V9(2).
           05 COMNUM7  PIC zzzzzz9.
           05 COMCONT  PIC 9(7).
           05 K1       PIC 99.
           05 PROG     PIC 9(5).
           05 CONT     PIC 9.
      **** rel 7.2
           05 COMEST   PIC 9.
           05 DISAB    PIC 9.
      ************
           05 PATH     PIC X(80).
           05 COMCFISC2.
              10 COMPIVA2 PIC 9(11).
              10 FILLER   PIC X(5).
           05 COMCFISC.
              10 COMPIVA  PIC 9(11).
              10 FILLER   PIC X(5).
           05 PRIMO    PIC 9.
           05 SAVCOD   PIC 9(7).
           05 MCLI     PIC 9(2).
           05 MFOR     PIC 9(2).
           05 CIVAV    PIC 9(7).
           05 CIVAQ    PIC 9(7).
           05 CIVSO    PIC 9(7).
           05 SOGCEE   PIC 9.
           05 CONTA    PIC 9(4).
           05 CONTROLLOK PIC 9.
           05 PRESENTE  PIC 9.
           05 CODICE1.
              10 MAS1 PIC 99.
              10 COD1 PIC 9(5).
           05 CODICE2.
              10 MAS2 PIC 99.
              10 COD2 PIC 9(5).
      *
       LINKAGE SECTION.
      *
      * Parametri locali di controllo interfaccia
      *
       01  IF-CTRL.
           05 IF-AZI       PIC 999.
           05 IF-FUN       PIC X.
           05 IF-CAMPO     PIC X(20).
           05 IF-ST        PIC 9.
      *
      * Record di interfaccia
      *
       01  IF-REC.
           05 IF-AZI-D     PIC X(36).
           05 IF-ANN       PIC 9(4).
           05 IF-TRIM      PIC 9.
           05 IF-SPD-D     PIC X(80).
           05 IF-TIPO      PIC 9.
           05 IF-NFILE     PIC X(18).
           05 IF-RIGA      PIC 9(7).
           05 IF-RETTIFICA PIC 9.
           05 IF-DAT-1     PIC 9(6).
           05 IF-DAT-2     PIC 9(6).
           05 IF-NODOC     PIC 9.
           05 IF-NODESCR   PIC 9.
      *
       01  IF-MESS         PIC X(204).
       PROCEDURE DIVISION USING IF-CTRL
                                IF-REC
                                IF-MESS.
           COPY 'declxer1'.
           COPY 'dclazi'.
           COPY 'dclaaz'.
           COPY 'dclsps'.
           COPY 'dclspd'.
           COPY 'dclsst'.
           COPY 'dcltab'.
           COPY 'dclclf'.
           COPY 'dclacf'.
           COPY 'dcllav'.
           COPY 'dclbkt'.
           COPY 'declxer2'.
       INIZIO.
           COPY 'strcal'.
           MOVE ZERO  TO IF-ST.
           MOVE SPACE TO IF-MESS.
           IF IF-FUN = 'E' AND FUN-PREC = 'E' GO TO ESCI.
           IF SWINI = ZERO PERFORM INI-ELABORA THRU EX-INI-ELABORA.
           MOVE IF-FUN   TO FUN.
           MOVE IF-CAMPO TO CAMPO.

           IF FUN = 'I' PERFORM INI-CAMPI THRU EX-INI-CAMPI
                        GO TO FINE.
           IF FUN = 'V' OR
                    'W' GO TO F-WALIDA.
           IF FUN = 'R' PERFORM RUN-ELABORA THRU EX-RUN-ELABORA
                        GO TO CHIUDI.
           IF FUN = 'E' GO TO CHIUDI.
           MOVE 'VSPS730: Funzione non ammessa' TO MESS.
           GO TO ERRIO.
      * - - - - - *
       F-WALIDA.
           PERFORM V-DATI THRU EX-V-DATI.
           IF VFLD = ZERO GO TO FINE.
           IF VFLD = 2 MOVE ZERO TO VFLD
                       GO TO WARNING.
           IF VFLD = 3 MOVE ZERO TO VFLD
                       GO TO QUESTION.
           MOVE VCAMPO TO IF-CAMPO.
           GO TO ERRFIELD.
      * - - - - - *
       ERRIO.
           COPY 'errcal'.
           MOVE ERRIO-ST TO IF-ST.
           IF ERRIO-ST < 9 GO TO FINE.
       CHIUDI.
           CLOSE ANAAZI.
           CLOSE APPAZI.
           CLOSE TABELL.
           CLOSE SPEDOC.
           CLOSE SPESOG.
           CLOSE SPETAB.
           CLOSE ANACLF.
           CLOSE APPCLF.
           CLOSE WDSLAV.
           CLOSE BLKTAB.
           OPEN OUTPUT WDSLAV.
           CLOSE WDSLAV.
           MOVE ZERO TO SWINI.
           MOVE 'E' TO FUN-PREC.
           GO TO ESCI.
       FINE.
           MOVE IF-FUN TO FUN-PREC.
       ESCI.
           IF ERRIO-ST > ZERO PERFORM ERRIO-MSG THRU EX-ERRIO-MSG
                              MOVE ERRIO-ST TO IF-ST.
           EXIT PROGRAM.
           COPY 'errmes'.
           COPY 'griazier'.
           COPY 'griaazer'.
           COPY 'grispser'.
           COPY 'grisster'.
           COPY 'grispder'.
           COPY 'gritaber'.
           COPY 'griclfer'.
           COPY 'griacfer'.
           COPY 'gribkter'.
           COPY 'grixxxer'.
      *------------------
      * inizializzazione di un ciclo di elaborazione 
      *    (iniz. screenset + validazioni + elaborazione/stampa)
       INI-ELABORA.
           PERFORM CREA-IDLAV THRU EX-CREA-IDLAV.
           OPEN INPUT ANAAZI.
           OPEN INPUT APPAZI.
           OPEN INPUT TABELL.
           OPEN INPUT ANACLF.
           OPEN INPUT APPCLF.
           OPEN INPUT BLKTAB.
           OPEN I-O SPETAB.
           OPEN I-O SPEDOC.
           OPEN I-O SPESOG.
           CLOSE WDSLAV.
           OPEN OUTPUT WDSLAV.
           CLOSE WDSLAV.
           OPEN I-O WDSLAV.
      *
           MOVE IF-AZI TO KAZ-COD.
           READ ANAAZI INTO REKAZI INVALID PERFORM INVK-AZI GO TO ERRIO.
           IF SF-AZI = '9D' OR '9A' OR '35' MOVE RF-AZI TO REKAZI.
      *
           MOVE 1 TO SWINI.
       EX-INI-ELABORA.
           EXIT.
      *------------------
      * inizializzazione interfaccia
       INI-CAMPI.
           MOVE AZRGSOC TO IF-AZI-D.

      *    ACCEPT GGMMAA FROM DATE.
      *    MOVE GG9 TO AAGGG.
      *    MOVE AA9 TO GG9.
      *    MOVE AAGGG TO AA9.
      *    MOVE GGMMAA TO IF-DTEM.
      *
           MOVE 02        TO J02-TIP.
           MOVE KAZ-COD   TO J02-COD.
           MOVE 'A'       TO J02-PRG.
           MOVE J02-KEYID TO KEYSST.
           READ SPETAB INTO REKJ02 INVALID PERFORM INVK-SST
                                   GO TO ERRIO.
           MOVE J02-PATHECF TO PATH.
           MOVE J02-PROG    TO PROG.
           MOVE J02-ANNO    TO IF-ANN.
      **** rel 7.2
           MOVE J02-SOLOEST TO COMEST.
      ************
      *
           MOVE IF-AZI TO KAZ-COD.
           READ ANAAZI INTO REKAZI INVALID PERFORM INVK-AZI GO TO ERRIO.
           IF SF-AZI = '9D' OR '9A' OR '35' MOVE RF-AZI TO REKAZI.
           MOVE SPACE TO COMCFISC2.
           IF AZI-CFISC NOT = SPACE AND AZI-CFISC NOT = ZERO AND
              AZI-CFISC(1:12) NOT = SPACE
              MOVE AZI-CFISC TO COMCFISC2
           ELSE
              IF AZI-CFISC(12:) = SPACE AND AZI-CFISC(1:11) IS NUMERIC
                 MOVE AZI-CFISC(1:11) TO COMPIVA2
              ELSE
                 MOVE AZI-PIVA TO COMPIVA2.
      *
           MOVE KAZ-COD TO KAAZ-COD.
           READ APPAZI INVALID PERFORM INVK-AAZ GO TO ERRIO.
      *
           MOVE 1 TO KTB-TIP KTB-COD.
           READ TABELL INTO REKTAB INVALID
                PERFORM INVK-TAB
                GO TO ERRIO.
           IF SF-TAB = '9D' OR '9A' OR '35' MOVE RF-TAB TO REKTAB.
           MOVE T01-MCLI TO MCLI.
           MOVE T01-MFOR TO MFOR.
           MOVE T01-CIVAV TO CIVAV.
           MOVE T01-CIVAQ TO CIVAQ.
           MOVE T01-CIVSO TO CIVSO.
      *
      *    MOVE 1 TO TIPOP1.
      *    MOVE IF-DTEM TO GGMMAA.
      *    CALL 'rdata' USING PARCDT.
      *    IF SWRET1 > ZERO
      *       PERFORM ERR-DATA
      *       GO TO V-ERROR.
      *    MOVE AA4   TO IF-ANN.
      *
      *    COMPUTE IF-TRIM = MM9 / 3  + 0,9.
      *    IF IF-TRIM NOT = 1
      *       SUBTRACT 1 FROM IF-TRIM
      *    ELSE
      *       MOVE 4 TO IF-TRIM
      *       SUBTRACT 1 FROM IF-ANN.
      *   
           STRING J02-PATHECF DELIMITED SPACE
                  INTO IF-SPD-D.
      *
           MOVE 2 TO IF-TIPO.
           MOVE SPACE TO IF-NFILE.
           MOVE ZERO TO IF-RIGA IF-RETTIFICA IF-NODOC IF-NODESCR.
      *
       EX-INI-CAMPI.
           EXIT.
      *------------------
      * validazione dei campi di interfaccia
       V-DATI.
           MOVE ZERO TO VFLD.
      *

      *V-ANN.
      *    MOVE 'IF-ANN' TO VCAMPO.
      *    IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-ANN.
      *    CALL 'ranno4' USING IF-ANN.
      *E-ANN.
      *
       V-DAT-1.
           MOVE 'IF-DAT-1' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-DAT-1.
           IF IF-DAT-1 = ZERO
              PERFORM ERR-ZERO
              GO TO V-ERROR.
           MOVE 1       TO TIPOP1.
           MOVE IF-DAT-1 TO GGMMAA.
           CALL 'rdata' USING PARCDT.
           IF SWRET1 > ZERO
              PERFORM ERR-DATA
              GO TO V-ERROR.
           MOVE AAGGG TO PKDT1.
            MOVE MM9 TO MM1.
            MOVE AA9 TO AA1.
      **** rel 7.2
      *    IF GG9 NOT = 1
      *       MOVE 'La data selezionata non rappresenta ' TO F-MES1
      *       MOVE 'l''inizio di un trimestre fiscale.  ' TO F-MES2
      *       MOVE 2 TO F-NMES
      *       MOVE 'W' TO MB-TIPO
      *       CALL 'vrmbox' USING PARMB
      *       GO TO E-DAT-1.
      *    IF MM9 NOT = 1 AND
      *       MM9 NOT = 4 AND
      *       MM9 NOT = 7 AND
      *       MM9 NOT = 10
      *       MOVE 'La data selezionata non rappresenta ' TO F-MES1
      *       MOVE 'l''inizio di un trimestre fiscale.  ' TO F-MES2
      *       MOVE 2 TO F-NMES
      *       MOVE 'W' TO MB-TIPO
      *       CALL 'vrmbox' USING PARMB.
      **********
       E-DAT-1.
      *
       V-DAT-2.
           MOVE 'IF-DAT-2' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-DAT-2.
           IF IF-DAT-1 = ZERO
              PERFORM ERR-ZERO
              GO TO V-ERROR.
           IF IF-DAT-2 = ZERO
              PERFORM ERR-ZERO
              GO TO V-ERROR.
           MOVE 1       TO TIPOP1.
           MOVE IF-DAT-1 TO GGMMAA.
           CALL 'rdata' USING PARCDT.
           IF SWRET1 > ZERO
              PERFORM ERR-DATA
              GO TO V-ERROR.
           MOVE AAGGG TO PKDT1.
           MOVE MM9 TO MM1.
           MOVE AA9 TO AA1.
      *
           MOVE 1       TO TIPOP1.
           MOVE IF-DAT-2 TO GGMMAA.
           CALL 'rdata' USING PARCDT.
           IF SWRET1 > ZERO
              PERFORM ERR-DATA
              GO TO V-ERROR.
           MOVE AAGGG TO PKDT2.
           MOVE MM9 TO MM2.
           MOVE AA9 TO AA2.
      *
           IF PKDT2 < AAGGG
              PERFORM ERR-DINV
              GO TO V-ERROR.
      *
      **** rel 7.2
      *    IF MM9 NOT = 3 AND
      *       MM9 NOT = 6 AND
      *       MM9 NOT = 9 AND
      *       MM9 NOT = 12
      *       MOVE 'La data selezionata non rappresenta ' TO F-MES1
      *       MOVE 'la fine di un trimestre fiscale.    ' TO F-MES2
      *       MOVE 2 TO F-NMES
      *       MOVE 'W' TO MB-TIPO
      *       CALL 'vrmbox' USING PARMB
      *       GO TO E-DAT-2.
      *    IF (MM9 = 3  AND GG9 NOT = 31) OR
      *       (MM9 = 6  AND GG9 NOT = 30) OR
      *       (MM9 = 9  AND GG9 NOT = 30) OR
      *       (MM9 = 12 AND GG9 NOT = 31)
      *       MOVE 'La data selezionata non rappresenta ' TO F-MES1
      *       MOVE 'la fine di un trimestre fiscale.    ' TO F-MES2
      *       MOVE 2 TO F-NMES
      *       MOVE 'W' TO MB-TIPO
      *       CALL 'vrmbox' USING PARMB
      *       GO TO E-DAT-2.
      *    IF MM1 = 1 AND MM2 NOT = 3 OR 
      *       MM1 = 4 AND MM2 NOT = 6 OR 
      *       MM1 = 7 AND MM2 NOT = 9 OR 
      *       MM1 = 10 AND MM2 NOT = 12
      *       MOVE 'Non si  selezionato un trimestre   ' TO F-MES1
      *       MOVE 'fiscale  corretto.                  ' TO F-MES2
      *       MOVE 2 TO F-NMES
      *       MOVE 'W' TO MB-TIPO
      *       CALL 'vrmbox' USING PARMB
      *       GO TO E-DAT-2.
      ************
           IF AA1 NOT = AA2
              MOVE 'Attenzione selezione su piu anni    ' TO F-MES1
              MOVE 1 TO F-NMES
              MOVE 'W' TO MB-TIPO
              CALL 'vrmbox' USING PARMB.
       E-DAT-2.
      *
           GO TO EX-V-DATI.
      *
       V-ERROR.
           MOVE 1 TO VFLD.
           GO TO EX-V-DATI.
       V-WARNING.
           MOVE 2 TO VFLD.
           GO TO EX-V-DATI.
       V-QUESTION.
           MOVE 3 TO VFLD.
       EX-V-DATI.
           EXIT.
      *------------------
      * elaborazione / stampa
       RUN-ELABORA.
      *
           PERFORM CREA-SORT-SOG THRU EX-CREA-SORT-SOG. 
           IF PRESENTE = ZERO
              IF IF-RETTIFICA = 1 OR IF-TIPO = 3
                 MOVE 'La registrazione che si sta cercando' TO F-MES1
                 MOVE 'di annullare/rettificare non esiste ' TO F-MES2
                 MOVE 2 TO F-NMES
                 CALL 'vrmbox' USING PARMB
                 GO TO EX-RUN-ELABORA.
      *
           IF IF-TIPO = 3
              PERFORM FILE-ANNULLAMENTO THRU EX-FILE-ANNULLAMENTO
              GO TO FINE-LAV.
       RIPARTI.
           MOVE ZERO TO SAVCOD COMCONT CONTA.
           MOVE LOW-VALUE TO KEYLV.
           MOVE IF-AZI    TO KLV-AZI.
           MOVE IF-ANN    TO KLV-ANNO.
           IF IF-TIPO = ZERO OR 2
              MOVE MCLI  TO MAS1 MAS2
              MOVE ZERO  TO COD1
              MOVE 99999 TO COD2
           ELSE
              MOVE MFOR  TO MAS1 MAS2
              MOVE ZERO  TO COD1
              MOVE 99999 TO COD2.
           MOVE CODICE1 TO KLV-COD.
       RIPARTI2.
           START WDSLAV KEY NOT < KEYLV INVALID GO TO FINE-LAV.
       RD-LAV.
           READ WDSLAV NEXT AT END GO TO FINE-LAV.
           IF KLV-AZI   > IF-AZI   GO TO FINE-LAV.
           IF KLV-ANNO  > IF-ANN   GO TO FINE-LAV.
           IF KLV-COD   > CODICE2  GO TO FINE-LAV.
           MOVE KLV-KEYSPD TO KEYSPD.
           READ SPEDOC INVALID GO TO RD-LAV.
      **** rel 7.2
           IF COMEST = 1
              PERFORM VERIFICA-DIS THRU EX-VERIFICA-DIS
              IF DISAB = 1
                 IF KLV-CD < 99999
                    ADD 1 TO KLV-CD
                    GO TO RIPARTI2
                 ELSE
                    GO TO FINE-LAV.
      ************
      *
           MOVE KLV-AZI TO KSPS-AZI.
           MOVE KLV-COD TO KSPS-COD.
           READ SPESOG INVALID KEY
                       MOVE SPACE TO REKSPS
                       MOVE 1 TO SPS-FLGBSE
                       MOVE ZERO TO SPS-STAB-CAP
                       MOVE HIGH-VALUE TO SPS-PIVA SPS-CFISC.
           IF SPS-DISABILITA = 1
      **** rel 7.2
      *       ADD 1 TO KLV-CD
      *       GO TO RIPARTI2.
              IF KLV-CD < 99999
                 ADD 1 TO KLV-CD
                 GO TO RIPARTI2
              ELSE
                 GO TO FINE-LAV.
      ************
      *
           MOVE KLV-AZI TO KCF-AZI.
           MOVE KLV-COD TO KCF-COD.
           READ ANACLF INTO REKCLF INVALID KEY
                               MOVE ALL '*' TO CLF-RGS
                               MOVE SPACE   TO CLF-RGS2
                               MOVE ZERO TO CLF-VAL.
      *
           MOVE KLV-AZI TO KACF-AZI.
           MOVE KLV-COD TO KACF-COD.
           READ APPCLF INVALID MOVE SPACE TO ACF-NAZIO.
      *
           MOVE ZERO TO SOGCEE.
           IF CLF-13IVA NOT = 4
              MOVE ZERO TO SOGCEE
           ELSE
              IF CLF-PAE IS NOT NUMERIC
                 IF CLF-PAE = 'IT' OR  CLF-PAE = SPACE
                    MOVE ZERO to SOGCEE 
                 ELSE
                    MOVE CLF-CFISC TO COMFISC
                    CALL 'rfisc' USING PARFISC
                    IF RISPFISC NOT = ZERO
                       MOVE 1    TO SOGCEE
                    ELSE
                       MOVE ZERO TO SOGCEE
                    END-IF
                 END-IF
              ELSE
                 MOVE ZERO to SOGCEE.
      *
           IF SAVCOD = ZERO
              PERFORM ES-HEADER THRU EX-ES-HEADER
              PERFORM ES-DATI-AZIENDA THRU EX-ES-DATI-AZIENDA.
      *
           IF SAVCOD NOT = KLV-COD 
              ADD 1 TO CONTA
              IF CONTA = 1001
                 PERFORM NUOVO THRU EX-NUOVO
              END-IF
      **** rel 7.2
      * Inizio CessionarioCommittenteDTE/DTR
              IF SAVCOD NOT = ZERO
                 MOVE '-'  TO PWXM-FUN
                 call 'vxml-wr-2-72' using parwxml
              END-IF
      ************
              MOVE KLV-COD TO SAVCOD
              PERFORM ES-DATI-SOGGETTO THRU EX-ES-DATI-SOGGETTO.
      *
      * Inizio DatiFatturaBodyDTE/DTR
           MOVE '+'  TO PWXM-FUN.
           IF KSPS-MS = MCLI
              MOVE 'DatiFatturaBodyDTE' TO PWXM-TAG
           ELSE
              MOVE 'DatiFatturaBodyDTR' TO PWXM-TAG.
           call 'vxml-wr-2-72' using parwxml.
      * Inizio DatiGenerali
           MOVE '+'  TO PWXM-FUN.
           MOVE 'DatiGenerali' TO PWXM-TAG.
           call 'vxml-wr-2-72' using parwxml.
      *
           MOVE 'TipoDocumento' TO PWXM-TAG
           MOVE SPD-TIPO TO PWXM-CAMPO.
           call 'vxml-wr-2-72' using parwxml. 
      *
           MOVE 'Data' TO PWXM-TAG
           MOVE 2 TO TIPOP1.
           MOVE SPD-DTDOC TO AAGGG.
           CALL 'rdata' USING PARCDT.
           STRING AA4 '-' MM9 '-' GG9 DELIMITED SIZE INTO PWXM-CAMPO.
           call 'vxml-wr-2-72' using parwxml. 
      *
           MOVE 'Numero' TO PWXM-TAG
           MOVE KSPD-NDOC TO PWXM-CAMPO
           IF CLF-13IVA = 3
              MOVE '0' TO PWXM-CAMPO.
           IF KSPD-MS = MFOR AND
              IF-NODOC = 1 
              MOVE '0' TO PWXM-CAMPO.
           call 'vxml-wr-2-72' using parwxml. 
       NODOCUM.
      *
           IF KSPD-MS = MFOR
              MOVE 'DataRegistrazione' TO PWXM-TAG
              MOVE 2 TO TIPOP1
              MOVE KSPD-DAT TO AAGGG
              CALL 'rdata' USING PARCDT
              STRING AA4 '-' MM9 '-' GG9 DELIMITED SIZE INTO PWXM-CAMPO
              call 'vxml-wr-2-72' using parwxml
           END-IF.
      *
      * Fine DatiGenerali
           MOVE '-'  TO PWXM-FUN.
           call 'vxml-wr-2-72' using parwxml.
      *
           MOVE 1 TO CONT.
       LOOPDATI.
           IF CONT > 8 GO TO FINE-LOOPDATI.
           IF SPD-IVA(CONT) = ZERO
              GO TO NOVALUE. 
      * Inizio DatiRiepilogo
           MOVE '+'  TO PWXM-FUN.
           MOVE 'DatiRiepilogo' TO PWXM-TAG.
           call 'vxml-wr-2-72' using parwxml.
      *
           MOVE 'ImponibileImporto' TO PWXM-TAG
           MOVE SPD-IMPON(CONT) TO COMNUM.
           PERFORM T-CIFRA THRU EX-T-CIFRA.
           STRING COMNUM(K1:10 - K1 + 1) '.' COMNUM(11:2)
                  DELIMITED SIZE INTO PWXM-CAMPO.
           IF SPD-IMPON(CONT) < ZERO
              MOVE SPACE TO PWXM-CAMPO
              STRING '-' COMNUM(K1:10 - K1 + 1) '.' COMNUM(11:2)
                     DELIMITED SIZE INTO PWXM-CAMPO.
           call 'vxml-wr-2-72' using parwxml. 
      * Inizio DatiIVA
           MOVE '+'  TO PWXM-FUN.
           MOVE 'DatiIVA' TO PWXM-TAG.
           call 'vxml-wr-2-72' using parwxml.
      *
      *    IF SPD-IMIVA(CONT) NOT = ZERO
              MOVE 'Imposta' TO PWXM-TAG
              MOVE SPD-IMIVA(CONT) TO COMNUM
              PERFORM T-CIFRA THRU EX-T-CIFRA
              STRING COMNUM(K1:10 - K1 + 1) '.' COMNUM(11:2)
                     DELIMITED SIZE INTO PWXM-CAMPO
              IF SPD-IMIVA(CONT) < ZERO
                 MOVE SPACE TO PWXM-CAMPO
                 STRING '-' COMNUM(K1:10 - K1 + 1) '.' COMNUM(11:2)
                        DELIMITED SIZE INTO PWXM-CAMPO
              END-IF
              call 'vxml-wr-2-72' using parwxml.
      *
           MOVE 3 TO KTB-TIP.
           MOVE SPD-IVA(CONT) TO KTB-COD.
           READ TABELL INTO REKTAB INVALID
                                 MOVE ZERO TO T03-ALIVA.
      *
           MOVE 'Aliquota' TO PWXM-TAG
           MOVE T03-ALIVA TO COMNUM.
           PERFORM T-CIFRA THRU EX-T-CIFRA.
           STRING COMNUM(K1:10 - K1 + 1) '.' COMNUM(11:2)
                  DELIMITED SIZE INTO PWXM-CAMPO.
           IF T03-ALIVA < ZERO
              MOVE SPACE TO PWXM-CAMPO
              STRING '-' COMNUM(K1:10 - K1 + 1) '.' COMNUM(11:2)
                     DELIMITED SIZE INTO PWXM-CAMPO.
           call 'vxml-wr-2-72' using parwxml. 
      *
           IF SPD-DEDU(CONT) = ZERO
              IF SPD-DETR(CONT) NOT = ZERO
                 MOVE 'Detraibile' TO PWXM-TAG
                 MOVE SPD-DETR(CONT) TO COMNUM
                 PERFORM T-CIFRA THRU EX-T-CIFRA
                 STRING COMNUM(K1:10 - K1 + 1) '.' COMNUM(11:2)
                     DELIMITED SIZE INTO PWXM-CAMPO
                 call 'vxml-wr-2-72' using parwxml
              END-IF
           ELSE
              MOVE 'Deducibile' TO PWXM-TAG
              MOVE 'SI' TO PWXM-CAMPO
              call 'vxml-wr-2-72' using parwxml.
      *
      * Fine DatiIVA
           MOVE '-'  TO PWXM-FUN.
           call 'vxml-wr-2-72' using parwxml.
      *
           IF SPD-NATUR(CONT) NOT = SPACE
              MOVE 'Natura' TO PWXM-TAG
              MOVE SPD-NATUR(CONT) TO PWXM-CAMPO
              call 'vxml-wr-2-72' using parwxml.
      *
           MOVE 'EsigibilitaIVA' TO PWXM-TAG.
           MOVE SPD-ESIG TO PWXM-CAMPO.
           call 'vxml-wr-2-72' using parwxml.
      *
      * Fine DatiRiepilogo
           MOVE '-'  TO PWXM-FUN.
           call 'vxml-wr-2-72' using parwxml.
      *
       NOVALUE.
           ADD 1 TO CONT.
           GO TO LOOPDATI.
       FINE-LOOPDATI.
      * Fine DatiFatturaBodyDTE/DTR
           MOVE '-'  TO PWXM-FUN.
           call 'vxml-wr-2-72' using parwxml.
      *
           ADD 1 TO COMCONT.
           MOVE PROG    TO SPD-PRGFILE.
           IF IF-RETTIFICA = ZERO
              MOVE SPACE   TO SPD-IDFILE
              MOVE COMCONT TO SPD-POSIZ.
           REWRITE RF-SPD.
      *
           GO TO RD-LAV.
       FINE-LAV.
           IF IF-TIPO = 2
              IF CONTA NOT = ZERO
      * Fine Schema
                 MOVE '-'  TO PWXM-FUN
                 call 'vxml-wr-2-72' using parwxml
      *
                 PERFORM RETTIFICA THRU EX-RETTIFICA
      *
                 MOVE 'E'  TO PWXM-FUN
                 call 'vxml-wr-2-72' using parwxml
              END-IF
      *
              MOVE 1 TO IF-TIPO
              GO TO RIPARTI.
      * Fine Schema
           IF CONTA NOT = ZERO
              MOVE '-'  TO PWXM-FUN
              call 'vxml-wr-2-72' using parwxml
      *
                 PERFORM RETTIFICA THRU EX-RETTIFICA
      *
              MOVE 'E'  TO PWXM-FUN
              call 'vxml-wr-2-72' using parwxml.
      *
       EX-RUN-ELABORA.
           EXIT.
      *------------------
       ES-HEADER.
           MOVE ZERO TO PARWXML.
           MOVE SPACE TO PWXM-NOMEFX.
           MOVE SPACE TO IF-SPD-D.
           ADD 1 TO PROG.
           STRING PATH DELIMITED SPACE
                  'IT' COMCFISC2 DELIMITED SPACE
                  '_DF_' PROG '.xml' DELIMITED SIZE
                  INTO IF-SPD-D.
           STRING IF-SPD-D DELIMITED SIZE INTO PWXM-NOMEFX.
           MOVE 02        TO J02-TIP.
           MOVE KAZ-COD   TO J02-COD.
           MOVE 'A'       TO J02-PRG.
           MOVE J02-KEYID TO KEYSST.
           READ SPETAB INTO REKJ02 INVALID PERFORM INVK-SST
                                   GO TO ERRIO.
           MOVE PROG TO J02-PROG.
           REWRITE RF-SST FROM REKJ02 INVALID PERFORM INVK-SST
                                   GO TO ERRIO.
      *
           MOVE 02        TO J02-TIP.
           MOVE KAZ-COD   TO J02-COD.
           MOVE 'B'       TO J02-PRG.
           MOVE J02-KEYID TO KEYSST.
           READ SPETAB INTO REKJ02 INVALID PERFORM INVK-SST
                                   GO TO ERRIO.
      *
           MOVE SPACE TO PWXM-FUN.
           MOVE SPACE TO PWXM-TAG.
           MOVE SPACE TO PWXM-ATTR.
           MOVE ZERO  TO PWXM-TIPO.
           MOVE SPACE TO PWXM-CAMPO.
           MOVE ZERO  TO PWXM-NUM.
           MOVE ZERO  TO PWXM-DATA.
           MOVE 'U'   TO PWXM-ENCODE.
      **** rel 7.2
           MOVE 'FEL' TO PWXM-TIP.    *> tipo formato FATTURAZIONE ELETTRONICA
      ************
      * Inizio XML
           MOVE '+'  TO PWXM-FUN.
           MOVE 'ns2:DatiFattura' TO PWXM-TAG.
      *
           MOVE 'versione' TO PWXM-NATTR(1).
           STRING 'DAT20' 
                   DELIMITED SIZE INTO PWXM-VATTR(1).
      *
           MOVE 'xmlns:ns2' TO PWXM-NATTR(2).
           STRING 
         'http://ivaservizi.agenziaentrate.gov.it/docs/xsd/fatture/v2.0'
                   DELIMITED SIZE INTO PWXM-VATTR(2).
           call 'vxml-wr-2-72' using parwxml.
      *
      **** rel 7.2
      *    MOVE 'xmlns' TO PWXM-NATTR(3).
      *    STRING 'http://ivaservizi.agenziaentrate.gov.it/docs/xsd/fat'
      *           'ture/v2.0'  DELIMITED SIZE INTO PWXM-VATTR(3).
      *
      *    MOVE 'targetNamespace' TO PWXM-NATTR(4).
      *    STRING 'http://ivaservizi.agenziaentrate.gov.it/docs/xsd/fat'
      *           'ture/v2.0' DELIMITED SIZE INTO PWXM-VATTR(4).
      *
      *    MOVE 'version' TO PWXM-NATTR(5).
      *    MOVE '1.0' TO PWXM-VATTR(5).
      *    call 'vxml-wr-2-72' using parwxml.
      ************
      *
      **** rel 7.2
      *    MOVE 'xs:import' TO PWXM-TAG.
      *    MOVE 'namespace' TO PWXM-NATTR(1).
      *    STRING 'http://www.w3.org/2000/09/xmldsig#' 
      *            DELIMITED SIZE INTO PWXM-VATTR(1).
      *    MOVE 'schemaLocation' TO PWXM-NATTR(2).
      *    STRING 'xmldsig-core-schema.xsd' 
      *            DELIMITED SIZE INTO PWXM-VATTR(2).
      *    call 'vxml-wr-2-72' using parwxml.
      ************
      *
      * Inizio DatiFatturaHeader
           MOVE '+'  TO PWXM-FUN.
           MOVE 'DatiFatturaHeader' TO PWXM-TAG.
           call 'vxml-wr-2-72' using parwxml.
      *
           MOVE 'ProgressivoInvio' TO PWXM-TAG.
           MOVE PROG TO PWXM-CAMPO.
           call 'vxml-wr-2-72' using parwxml.
      *
           IF J02-CFDIC NOT = SPACE
              MOVE '+'  TO PWXM-FUN
              MOVE 'Dichiarante' TO PWXM-TAG
              call 'vxml-wr-2-72' using parwxml
      *
              MOVE 'CodiceFiscale' TO PWXM-TAG
              MOVE J02-CFDIC TO PWXM-CAMPO
              call 'vxml-wr-2-72' using parwxml
              MOVE 'Carica' TO PWXM-TAG
      *
             IF J02-CADIC < 10
                MOVE J02-CADIC(2:1) TO PWXM-CAMPO
             ELSE
                MOVE J02-CADIC      TO PWXM-CAMPO
             END-IF
             call 'vxml-wr-2-72' using parwxml
      *
             MOVE '-'  TO PWXM-FUN
             call 'vxml-wr-2-72' using parwxml.
      *
      *    MOVE 'IdSistema' TO PWXM-TAG.
      *    MOVE SPACE TO PWXM-CAMPO.
      *    call 'vxml-wr-2-72' using parwxml.
      *Fine DatiFatturaHeader
           MOVE '-'  TO PWXM-FUN.
           call 'vxml-wr-2-72' using parwxml.
      *Inizio DTE/DTR/ANN
           MOVE '+'  TO PWXM-FUN.
           IF IF-TIPO = 3
              MOVE 'ANN' TO PWXM-TAG
           ELSE
              IF KSPS-MS = MCLI
                 MOVE 'DTE' TO PWXM-TAG
              ELSE
                 MOVE 'DTR' TO PWXM-TAG.
           call 'vxml-wr-2-72' using parwxml.
      *
       EX-ES-HEADER.
           EXIT.
      *------------------
       ES-DATI-AZIENDA.
      * Inizio CedentePrestatoreDTE/CessionarioCommittenteDTR
           MOVE '+'  TO PWXM-FUN.
           IF KSPS-MS = MCLI
              MOVE 'CedentePrestatoreDTE' TO PWXM-TAG
           ELSE
              MOVE 'CessionarioCommittenteDTR' TO PWXM-TAG.
           call 'vxml-wr-2-72' using parwxml.
      * Inizio IdentificativiFiscali
           MOVE '+'  TO PWXM-FUN.
           MOVE 'IdentificativiFiscali' TO PWXM-TAG.
           call 'vxml-wr-2-72' using parwxml.
      * Inizio IdFiscaleIVA
           MOVE '+'  TO PWXM-FUN.
           MOVE 'IdFiscaleIVA' TO PWXM-TAG.
           call 'vxml-wr-2-72' using parwxml.
      *
           MOVE 'IdPaese' TO PWXM-TAG.
           MOVE 'IT' TO PWXM-CAMPO.
           call 'vxml-wr-2-72' using parwxml.
      *
           MOVE 'IdCodice' TO PWXM-TAG.
           MOVE AZI-PIVA TO PWXM-CAMPO.
           call 'vxml-wr-2-72' using parwxml.
      * Fine IdFiscaleIVA
           MOVE '-'  TO PWXM-FUN.
           call 'vxml-wr-2-72' using parwxml.
      *
           IF AZI-CFISC(12:5) NOT = SPACE
              MOVE 'CodiceFiscale' TO PWXM-TAG
              MOVE AZI-CFISC TO PWXM-CAMPO
              call 'vxml-wr-2-72' using parwxml.
      * Fine IdentificativiFiscali
           MOVE '-'  TO PWXM-FUN.
           call 'vxml-wr-2-72' using parwxml.
      * Inizio AltriDatiIdentificativi
           MOVE '+'  TO PWXM-FUN.
           MOVE 'AltriDatiIdentificativi' TO PWXM-TAG.
           call 'vxml-wr-2-72' using parwxml.
      *
           IF AAZ-CGN = SPACE 
              MOVE 'Denominazione' TO PWXM-TAG
              MOVE AZI-RGSOC TO PWXM-CAMPO
              call 'vxml-wr-2-72' using parwxml
           ELSE
              MOVE 'Nome' TO PWXM-TAG
              MOVE AAZ-NOM TO PWXM-CAMPO
              call 'vxml-wr-2-72' using parwxml 
      *
              MOVE 'Cognome' TO PWXM-TAG
              MOVE AAZ-CGN TO PWXM-CAMPO
              call 'vxml-wr-2-72' using parwxml. 
      * Inizio Sede
           MOVE '+'  TO PWXM-FUN.
           MOVE 'Sede' TO PWXM-TAG.
           call 'vxml-wr-2-72' using parwxml.
      *
           MOVE 'Indirizzo' TO PWXM-TAG
           MOVE AZI-INDIR TO PWXM-CAMPO
           call 'vxml-wr-2-72' using parwxml. 
      *
           MOVE 'CAP' TO PWXM-TAG
           MOVE AZI-CAP   TO PWXM-CAMPO
           call 'vxml-wr-2-72' using parwxml. 
      *
           MOVE 'Comune' TO PWXM-TAG
           MOVE AZI-CIT   TO PWXM-CAMPO
           call 'vxml-wr-2-72' using parwxml. 
      *
           IF AZI-PRV NOT = SPACE
              MOVE 'Provincia' TO PWXM-TAG
              MOVE AZI-PRV   TO PWXM-CAMPO
              call 'vxml-wr-2-72' using parwxml. 
      *
           MOVE 'Nazione' TO PWXM-TAG
           MOVE 'IT'         TO PWXM-CAMPO
           call 'vxml-wr-2-72' using parwxml. 
      * Fine Sede
           MOVE '-'  TO PWXM-FUN.
           call 'vxml-wr-2-72' using parwxml.
      *
           MOVE 02        TO J02-TIP.
           MOVE KAZ-COD   TO J02-COD.
           MOVE 'D'       TO J02-PRG.
           MOVE J02-KEYID TO KEYSST.
           READ SPETAB INTO REKJ02 INVALID PERFORM INVK-SST
                                   GO TO ERRIO.
      *
           IF J02-STAB-XIND = SPACE AND
              J02-STAB-CAP  = ZERO  AND
              J02-STAB-CIT  = SPACE AND
              J02-STAB-PRV  = SPACE AND
              J02-STAB-NAZ  = SPACE
              GO TO NOSTABILE1.
      * Inizio StabileOrganizzazione
           MOVE '+'  TO PWXM-FUN.
           MOVE 'StabileOrganizzazione' TO PWXM-TAG.
           call 'vxml-wr-2-72' using parwxml.
      *
           MOVE 'Indirizzo' TO PWXM-TAG.
           MOVE J02-STAB-XIND TO PWXM-CAMPO.
           call 'vxml-wr-2-72' using parwxml. 
      *
           MOVE 'CAP' TO PWXM-TAG.
           MOVE J02-STAB-CAP TO PWXM-CAMPO.
           call 'vxml-wr-2-72' using parwxml. 
      *
           MOVE 'Comune' TO PWXM-TAG.
           MOVE J02-STAB-CIT TO PWXM-CAMPO.
           call 'vxml-wr-2-72' using parwxml. 
      *
           IF J02-STAB-PRV NOT = SPACE
              MOVE 'Provincia' TO PWXM-TAG
              MOVE J02-STAB-PRV TO PWXM-CAMPO
              call 'vxml-wr-2-72' using parwxml. 
      *
           MOVE 'Nazione' TO PWXM-TAG.
           MOVE J02-STAB-NAZ TO PWXM-CAMPO.
           call 'vxml-wr-2-72' using parwxml. 
      * Fine StabileOrganizzazione
           MOVE '-'  TO PWXM-FUN.
           call 'vxml-wr-2-72' using parwxml.
      *
           GO TO NORAPR1.
       NOSTABILE1.
      *
           IF J02-CFRAP  = SPACE AND
              J02-CORAP  = SPACE AND
              J02-NORAP  = SPACE AND
              J02-NAZRAP = SPACE AND
              J02-DENOM  = SPACE
              GO TO NORAPR1.
      * Inizio RappresentanteFiscale
           MOVE '+'  TO PWXM-FUN.
           MOVE 'RappresentanteFiscale' TO PWXM-TAG.
           call 'vxml-wr-2-72' using parwxml.
      * Inizio IdFiscaleIVA
           MOVE '+'  TO PWXM-FUN.
           MOVE 'IdFiscaleIVA' TO PWXM-TAG.
           call 'vxml-wr-2-72' using parwxml.
      *
           MOVE 'IdPaese' TO PWXM-TAG.
           MOVE J02-NAZRAP   TO PWXM-CAMPO.
           call 'vxml-wr-2-72' using parwxml. 
      *
           MOVE 'IdCodice' TO PWXM-TAG.
           MOVE J02-CFRAP   TO PWXM-CAMPO.
           call 'vxml-wr-2-72' using parwxml.
      * Fine IdFiscaleIVA
           MOVE '-'  TO PWXM-FUN.
           call 'vxml-wr-2-72' using parwxml.
      *
           IF J02-CORAP = SPACE
              MOVE 'Denominazione' TO PWXM-TAG
              MOVE J02-DENOM   TO PWXM-CAMPO
              call 'vxml-wr-2-72' using parwxml 
           ELSE
              MOVE 'Nome' TO PWXM-TAG
              MOVE J02-NORAP   TO PWXM-CAMPO
              call 'vxml-wr-2-72' using parwxml 
      *
              MOVE 'Cognome' TO PWXM-TAG
              MOVE J02-CORAP   TO PWXM-CAMPO
              call 'vxml-wr-2-72' using parwxml. 
      * Fine RappresentanteFiscale
           MOVE '-'  TO PWXM-FUN.
           call 'vxml-wr-2-72' using parwxml.
       NORAPR1.
      * Fine AltriDatiIdentificativi
           MOVE '-'  TO PWXM-FUN.
           call 'vxml-wr-2-72' using parwxml.
      * Fine CedentePrestatoreDTE/DTR
           MOVE '-'  TO PWXM-FUN.
           call 'vxml-wr-2-72' using parwxml.
       EX-ES-DATI-AZIENDA.
           EXIT.
      *------------------
       ES-DATI-SOGGETTO.
           MOVE ZERO TO PARDSPS.
           MOVE KLV-AZI TO PDSPS-AZI.
           IF KSPS-MS = MCLI
              MOVE 'C' TO PDSPS-CFGO
           ELSE
              MOVE 'F' TO PDSPS-CFGO.
           MOVE KLV-CD TO PDSPS-SOG.
           CALL 'vrcdsps' USING PARDSPS.
      *
      * Inizio CessionarioCommittenteDTE/CedentePrestatoreDTR
           MOVE '+'  TO PWXM-FUN.
           IF KSPS-MS = MCLI
              MOVE 'CessionarioCommittenteDTE' TO PWXM-TAG
           ELSE
              MOVE 'CedentePrestatoreDTR' TO PWXM-TAG.
           call 'vxml-wr-2-72' using parwxml.
      * Inizio IdentificativiFiscali
           MOVE '+'  TO PWXM-FUN.
           MOVE 'IdentificativiFiscali' TO PWXM-TAG.
           call 'vxml-wr-2-72' using parwxml.
      *
           IF PDSPS-PIVA = SPACE GO NOPIVA. 
      * Inizio IdFiscaleIVA
           MOVE '+'  TO PWXM-FUN.
           MOVE 'IdFiscaleIVA' TO PWXM-TAG.
           call 'vxml-wr-2-72' using parwxml.
      *
           MOVE 'IdPaese' TO PWXM-TAG.
           MOVE PDSPS-NAZ TO PWXM-CAMPO.
           call 'vxml-wr-2-72' using parwxml.
      *
           MOVE 'IdCodice' TO PWXM-TAG.
           MOVE PDSPS-PIVA TO PWXM-CAMPO.
           call 'vxml-wr-2-72' using parwxml.
      * Fine IdFiscaleIVA
           MOVE '-'  TO PWXM-FUN.
           call 'vxml-wr-2-72' using parwxml.
      *
           GO TO BD.
       NOPIVA.
      *
           IF PDSPS-CFISC NOT = SPACE
               MOVE 'CodiceFiscale' TO PWXM-TAG
               MOVE PDSPS-CFISC TO PWXM-CAMPO
               call 'vxml-wr-2-72' using parwxml.
       BD.
      * Fine IdentificativiFiscali
           MOVE '-'  TO PWXM-FUN.
           call 'vxml-wr-2-72' using parwxml.
           IF IF-NODESCR = 1 AND
              PDSPS-NAZ = 'IT' GO TO NOANAG.
      * Inizio AltriDatiIdentificativi
           MOVE '+'  TO PWXM-FUN.
           MOVE 'AltriDatiIdentificativi' TO PWXM-TAG.
           call 'vxml-wr-2-72' using parwxml.
      *
           IF SPS-COGNOME = SPACE 
              MOVE 'Denominazione' TO PWXM-TAG
              MOVE CLF-XRGS TO PWXM-CAMPO
              IF CLF-13IVA = 3
                 MOVE 'Dato Assente' TO PWXM-CAMPO
              END-IF
              call 'vxml-wr-2-72' using parwxml
           ELSE
              MOVE 'Nome' TO PWXM-TAG
              MOVE SPS-NOME TO PWXM-CAMPO
              call 'vxml-wr-2-72' using parwxml 
      *
              MOVE 'Cognome' TO PWXM-TAG
              MOVE SPS-COGNOME TO PWXM-CAMPO
              call 'vxml-wr-2-72' using parwxml. 
           IF CLF-13IVA NOT = 3
              IF CLF-XIND = SPACE AND
                 CLF-CAP = ZERO AND
                 CLF-CIT = SPACE
                 GO TO NOSEDE. 
      * Inizio Sede
           MOVE '+'  TO PWXM-FUN.
           MOVE 'Sede' TO PWXM-TAG.
           call 'vxml-wr-2-72' using parwxml.
      *
           MOVE 'Indirizzo' TO PWXM-TAG
           MOVE CLF-XIND TO PWXM-CAMPO
           IF CLF-13IVA = 3
              MOVE 'Dato Assente' TO PWXM-CAMPO.
           call 'vxml-wr-2-72' using parwxml. 
      *
           IF PDSPS-NAZ = 'IT'
              IF CLF-CAP NOT = ZERO
                 MOVE 'CAP' TO PWXM-TAG
                 MOVE CLF-CAP   TO PWXM-CAMPO
                 call 'vxml-wr-2-72' using parwxml. 
      *
           MOVE 'Comune' TO PWXM-TAG
           MOVE CLF-CIT   TO PWXM-CAMPO
           IF CLF-13IVA = 3
              MOVE 'Dato Assente' TO PWXM-CAMPO.
           call 'vxml-wr-2-72' using parwxml. 
      *
           IF PDSPS-NAZ = 'IT'
              IF CLF-PRV NOT = SPACE
      *
                 MOVE CLF-PRV TO UL-STR
                 MOVE 'U' TO UL-FUN
                 CALL 'ruplo' USING PARUL
                 MOVE UL-STR TO CLF-PRV
      *
                 MOVE 'Provincia' TO PWXM-TAG
                 MOVE CLF-PRV   TO PWXM-CAMPO
                 call 'vxml-wr-2-72' using parwxml. 
      *
           MOVE 'Nazione' TO PWXM-TAG
           MOVE PDSPS-NAZ TO PWXM-CAMPO.
           IF CLF-13IVA = 3
              MOVE 'OO' TO PWXM-CAMPO.
           call 'vxml-wr-2-72' using parwxml. 
      * Fine Sede
           MOVE '-'  TO PWXM-FUN.
           call 'vxml-wr-2-72' using parwxml.
       NOSEDE.
           IF SPS-STAB-XIND = SPACE AND
              SPS-STAB-CAP  = ZERO  AND
              SPS-STAB-CIT  = SPACE AND
              SPS-STAB-PRV  = SPACE AND
              SPS-STAB-NAZ  = SPACE
              GO TO NOSTABILE.
      * Inizio StabileOrganizzazione
           MOVE '+'  TO PWXM-FUN.
           MOVE 'StabileOrganizzazione' TO PWXM-TAG.
           call 'vxml-wr-2-72' using parwxml.
      *
           MOVE 'Indirizzo' TO PWXM-TAG.
           MOVE SPS-STAB-XIND TO PWXM-CAMPO.
           call 'vxml-wr-2-72' using parwxml. 
      *
           MOVE 'CAP' TO PWXM-TAG.
           MOVE SPS-STAB-CAP TO PWXM-CAMPO.
           call 'vxml-wr-2-72' using parwxml. 
      *
           MOVE 'Comune' TO PWXM-TAG.
           MOVE SPS-STAB-CIT TO PWXM-CAMPO.
           call 'vxml-wr-2-72' using parwxml. 
      *
           IF SPS-STAB-PRV NOT = SPACE
              MOVE 'Provincia' TO PWXM-TAG
              MOVE SPS-STAB-PRV TO PWXM-CAMPO
              call 'vxml-wr-2-72' using parwxml. 
      *
           MOVE 'Nazione' TO PWXM-TAG.
           MOVE SPS-STAB-NAZ TO PWXM-CAMPO.
           call 'vxml-wr-2-72' using parwxml. 
      * Fine StabileOrganizzazione
           MOVE '-'  TO PWXM-FUN.
           call 'vxml-wr-2-72' using parwxml.
      *
           GO TO NORAPR.
       NOSTABILE.
      *
           IF SPS-RAPR-PAESE = SPACE   AND
              SPS-RAPR-NOME  = SPACE   AND
              SPS-RAPR-IDFISC  = SPACE AND
              SPS-RAPR-DENOM  = SPACE  AND
              SPS-RAPR-COGNOME  = SPACE
              GO TO NORAPR.
      * Inizio RappresentanteFiscale
           MOVE '+'  TO PWXM-FUN.
           MOVE 'RappresentanteFiscale' TO PWXM-TAG.
           call 'vxml-wr-2-72' using parwxml.
      * Inizio IdFiscaleIVA
           MOVE '+'  TO PWXM-FUN.
           MOVE 'IdFiscaleIVA' TO PWXM-TAG.
           call 'vxml-wr-2-72' using parwxml.
      *
           MOVE 'IdPaese' TO PWXM-TAG.
           MOVE SPS-RAPR-PAESE   TO PWXM-CAMPO.
           call 'vxml-wr-2-72' using parwxml. 
      *
           MOVE 'IdCodice' TO PWXM-TAG.
           MOVE SPS-RAPR-IDFISC   TO PWXM-CAMPO.
           call 'vxml-wr-2-72' using parwxml.
      * Fine IdFiscaleIVA
           MOVE '-'  TO PWXM-FUN.
           call 'vxml-wr-2-72' using parwxml.
      *
           IF SPS-RAPR-COGNOME = SPACE
              MOVE 'Denominazione' TO PWXM-TAG
              MOVE SPS-RAPR-DENOM   TO PWXM-CAMPO
              call 'vxml-wr-2-72' using parwxml 
           ELSE
              MOVE 'Nome' TO PWXM-TAG
              MOVE SPS-RAPR-NOME   TO PWXM-CAMPO
              call 'vxml-wr-2-72' using parwxml 
      *
              MOVE 'Cognome' TO PWXM-TAG
              MOVE SPS-RAPR-COGNOME   TO PWXM-CAMPO
              call 'vxml-wr-2-72' using parwxml. 
      * Fine RappresentanteFiscale
           MOVE '-'  TO PWXM-FUN.
           call 'vxml-wr-2-72' using parwxml.
       NORAPR.
      * Fine AltriDatiIdentificativi
           MOVE '-'  TO PWXM-FUN.
           call 'vxml-wr-2-72' using parwxml.
       NOANAG.
      **** rel 7.2
      * Inizio CessionarioCommittenteDTE/DTR
      *    MOVE '-'  TO PWXM-FUN.
      *    call 'vxml-wr-2-72' using parwxml.
      ************
       EX-ES-DATI-SOGGETTO.
           EXIT.
      *------------------
       T-CIFRA.
           MOVE 1 TO K1.
           PERFORM UNTIL COMNUM(K1:1) NOT = ZERO
             ADD 1 TO K1. 
           IF K1 > 10
              MOVE 10 TO K1. 
       EX-T-CIFRA.
           EXIT.
      *------------------
       CREA-SORT-SOG.
           MOVE LOW-VALUE TO KEYSPD.
           MOVE IF-AZI TO KSPD-AZI.
           MOVE PKDT1  TO KSPD-DAT.
           MOVE SPACE TO SPD-IDFILE.
           MOVE ZERO  TO SPD-PRGFILE PRESENTE.
           START SPEDOC KEY NOT < SKEYSPD9 INVALID GO TO FINE-SPD1.
       RD-SPD1.
           READ SPEDOC NEXT AT END GO TO FINE-SPD1.
           IF KSPD-AZI > IF-AZI GO TO FINE-SPD1.
           IF KSPD-DAT > PKDT2  GO TO FINE-SPD1.
           IF IF-RETTIFICA = 1
              IF SPD-IDFILE NOT = IF-NFILE 
                 GO TO RD-SPD1
              END-IF
              IF SPD-POSIZ NOT = IF-RIGA
                 GO TO RD-SPD1.
      *
           IF IF-TIPO = 3
              IF IF-NFILE NOT = SPD-IDFILE
                 GO TO RD-SPD1
              END-IF
              IF IF-RIGA NOT = ZERO
                 IF SPD-POSIZ NOT = IF-RIGA
                    GO TO RD-SPD1.
      *
           MOVE 1 TO PRESENTE. 
      *
           MOVE KSPD-AZI  TO KLV-AZI.
           MOVE KSPD-ANNO TO KLV-ANNO.
           MOVE KSPD-COD  TO KLV-COD.
           MOVE KEYSPD    TO KLV-KEYSPD.
           IF SPD-SOG2 NOT = ZERO
              MOVE SPD-SOG2 TO KLV-CD.
      *
           WRITE RF-LAV.
      *
           GO TO RD-SPD1.
       FINE-SPD1.
       EX-CREA-SORT-SOG.
           EXIT.
      *------------------
       CREA-IDLAV.
           MOVE SPACE TO ID-LAV.
           STRING 'w1' PID DELIMITED SPACE INTO ID-LAV.
       EX-CREA-IDLAV.
           EXIT.
      *------------------
       NUOVO.
           MOVE ZERO TO CONT SAVCOD COMCONT.
           MOVE 1 TO CONTA.
      * Fine Schema
              MOVE '-'  TO PWXM-FUN
              call 'vxml-wr-2-72' using parwxml
      *
              MOVE 'E'  TO PWXM-FUN
              call 'vxml-wr-2-72' using parwxml
      *     
           PERFORM ES-HEADER THRU EX-ES-HEADER.
           PERFORM ES-DATI-AZIENDA THRU EX-ES-DATI-AZIENDA.
       EX-NUOVO.
           EXIT.
      *------------------
       FILE-ANNULLAMENTO.
           PERFORM ES-HEADER THRU EX-ES-HEADER.
      *
           MOVE 'IdFile' TO PWXM-TAG
           MOVE IF-NFILE   TO PWXM-CAMPO
           call 'vxml-wr-2-72' using parwxml 
      *
           IF IF-RIGA NOT = ZERO
              MOVE 'Posizione' TO PWXM-TAG
              MOVE IF-RIGA TO COMNUM7
              MOVE COMNUM7 TO PWXM-CAMPO
              call 'vxml-wr-2-72' using parwxml. 
      *
       EX-FILE-ANNULLAMENTO.
           EXIT.
      *------------------
       RETTIFICA.
           IF IF-RETTIFICA = 1
      * Inizio Rettifica
              MOVE '+'  TO PWXM-FUN
              MOVE 'Rettifica' TO PWXM-TAG
              call 'vxml-wr-2-72' using parwxml
      *
              MOVE 'IdFile' TO PWXM-TAG
              MOVE IF-NFILE   TO PWXM-CAMPO
              call 'vxml-wr-2-72' using parwxml 
      *
              MOVE 'Posizione' TO PWXM-TAG
              MOVE IF-RIGA TO COMNUM7
              MOVE COMNUM7 TO PWXM-CAMPO
              call 'vxml-wr-2-72' using parwxml 
      *
      * Fine Rettifica
              MOVE '-'  TO PWXM-FUN
              call 'vxml-wr-2-72' using parwxml.
      *
       EX-RETTIFICA.
           EXIT.
      *------------------
      **** rel 7.2
       VERIFICA-DIS.
           MOVE ZERO TO DISAB.
           MOVE ZERO TO RF-SPS.
      *
           MOVE KSPD-AZI TO KSPS-AZI.
           MOVE KSPD-COD TO KSPS-COD.
           READ SPESOG INVALID KEY
                       MOVE ZERO TO SPS-DISABILITA.
           MOVE SPS-DISABILITA TO DISAB.
           MOVE ZERO TO RF-SPS.
      *
       EX-VERIFICA-DIS.
           EXIT.
      *------------------
      ************
