       IDENTIFICATION DIVISION.
       PROGRAM-ID. VRPXML.
      *
      *  Routine per parametri XML
      *
      **** rel 7.2
      * nuovo
      ************
       ENVIRONMENT DIVISION.
       INPUT-OUTPUT SECTION.
       FILE-CONTROL.
           SELECT FILTST ASSIGN TO DISK 
                  ORGANIZATION LINE SEQUENTIAL
                  STATUS SF-TST.
       DATA DIVISION.
       FILE SECTION.
       FD  FILTST LABEL RECORD STANDARD
           VALUE OF FILE-ID ID-TST 
           RECORD 240 DATA RECORD RF-TST.
       01  RF-TST.
           05 TST-RIGA     PIC X(240).
       WORKING-STORAGE SECTION.
           COPY 'grirel-72'.
           COPY 'parzf'.
       01  ID-TST  PIC X(60).
       01  SF-TST  PIC XX.
       01  AREE.
           05 SAVTIP   PIC XXX VALUE HIGH-VALUE.
           05 IND      PIC 99 VALUE ZERO.
           05 FLGA     PIC 9  VALUE ZERO.
           05 CAMPO    PIC X(21) VALUE SPACE.
           05 NADD     PIC 99 VALUE ZERO.
           05 NMAX     PIC 99 VALUE ZERO.

           05 ASCII PIC 999 COMP.
           05 FILLER REDEFINES ASCII.
              10 FILLER PIC X.
              10 STR    PIC X.

       78  V-MAX  VALUE 50.
       01  V-IND PIC 99.
       01  V-MAP OCCURS V-MAX.
           05 V-IN   PIC X.
           05 V-OUT  PIC X(20).
           05 V-LL   PIC 99.
      *----------------------------------------
       LINKAGE SECTION.
           COPY 'parpxml'.
       PROCEDURE DIVISION USING PARPXML.
       INIZIO.
           COPY 'strsub'.
      *
           MOVE ZERO  TO PXML-ERR.

           MOVE SPACE TO PXML-OUT.
           MOVE ZERO  TO PXML-LL.

           IF PXML-TIP = '000' OR LOW-VALUE OR HIGH-VALUE
              MOVE SPACE TO PXML-TIP.

           IF SAVTIP NOT = HIGH-VALUE AND
              SAVTIP = PXML-TIP GO TO NO-FILE.
      *      
           MOVE SPACE TO ID-TST.
           STRING EX-UTI '\xmlmap' DELIMITED SPACE INTO ID-TST.

           OPEN INPUT FILTST.
           IF SF-TST NOT = ZERO GO TO FINE.

           MOVE ZERO TO V-IND.

           MOVE ZERO TO FLGA.
       TAB10.
           READ FILTST.
           IF SF-TST > '02'       GO TO TAB90.
           IF TST-RIGA(1:1) = '#' GO TO TAB10.
           IF RF-TST = SPACE      GO TO TAB10.

      * Acquisizione progetto
           IF TST-RIGA(1:5) = '[tip]'
              IF TST-RIGA(6:) = SPACE
                 GO TO TAB10
              ELSE
                 IF TST-RIGA(7:3) = PXML-TIP
                    MOVE 1 TO FLGA
                 ELSE
                    MOVE 9 TO FLGA
                 END-IF
                 GO TO TAB10.

      * Acquisizione mappatura caratteri
           IF TST-RIGA(1:5) = '[map]'
              IF TST-RIGA(6:) = SPACE
                 GO TO TAB10
              ELSE
                 IF FLGA NOT = 9
                    IF V-IND < V-MAX
                       ADD 1 TO V-IND
                       MOVE TST-RIGA(7:3) TO ASCII
                       MOVE STR TO V-IN(V-IND)
      *
                       MOVE SPACE TO V-OUT(V-IND)
                       MOVE 1 TO V-LL(V-IND)
      *
                       MOVE TST-RIGA(11:21) TO CAMPO
                       MOVE 3 TO NADD
                       MOVE 7 TO NMAX
                       IF CAMPO(1:1) = '&'
                          MOVE 1 TO NADD
                          MOVE 21 TO NMAX
                       END-IF
      *
                       MOVE 1 TO IND
                       PERFORM UNTIL IND > NMAX
                          IF NADD = 3
                             IF CAMPO(1 + NADD * (IND - 1):NADD) NUMERIC
                                MOVE CAMPO(1 + NADD * (IND - 1):NADD)
                                     TO ASCII
                                STRING STR INTO V-OUT(V-IND)
                                       POINTER V-LL(V-IND)
                             END-IF
                          ELSE
                             IF CAMPO(1 + (NADD * (IND - 1)):)
                                     NOT = SPACE
                                STRING CAMPO(1 + NADD * (IND - 1):NADD)
                                       INTO V-OUT(V-IND)
                                       POINTER V-LL(V-IND)
                             END-IF
                          END-IF
                          ADD 1 TO IND
                       END-PERFORM
      *
                       SUBTRACT 1 FROM V-LL(V-IND)

.     *             display v-ind " " V-IN(v-ind) " "
.     *                     V-OUT(v-ind) " " V-LL(v-ind)
                    END-IF
                 END-IF
                 GO TO TAB10.

           GO TO TAB10.
      *
       TAB90.
           CLOSE FILTST.

           MOVE PXML-TIP TO SAVTIP.

       NO-FILE.
      *
           MOVE 1 TO IND.
           PERFORM UNTIL IND > V-IND
              IF PXML-IN = V-IN(IND)
                 MOVE V-OUT(IND) TO PXML-OUT
                 MOVE V-LL(IND) TO PXML-LL
              END-IF
              ADD 1 TO IND.

           GO TO FINE.
      * 
       ERRORE.
           MOVE 9 TO PXML-ERR.
           GO TO FINE.
      *
       FINE.
           EXIT PROGRAM.
      *------------------
