       IDENTIFICATION DIVISION.
       PROGRAM-ID. VRGTF4.
      *
      *    Interfaccia TABFEL per fatture elettroniche
      *
      **** rel 7.1
      * Nuovo
      ************
       ENVIRONMENT DIVISION.
       CONFIGURATION SECTION.
       SPECIAL-NAMES. DECIMAL-POINT IS COMMA.
       INPUT-OUTPUT SECTION.
       FILE-CONTROL.
           COPY 'griazisl'.
           COPY 'gritfesl'.
           COPY 'gritf2sl'.
           COPY 'gritabsl'.
       DATA DIVISION.
       FILE SECTION.
           COPY 'griazi'.
           COPY 'gritfe'.
           COPY 'gritf2'.
           COPY 'gritab'.
       WORKING-STORAGE SECTION.
           COPY 'grirel-72'.
           COPY 'griazirk'.
           COPY 'grit50rk'.
           COPY 'parzf'.
           COPY 'parcdt'.
       01  ID-AZI PIC X(15) VALUE 'anaazi'.
       01  ID-TFE PIC X(15) VALUE 'tabfel'.
       01  ID-TF2 PIC X(15) VALUE 'tabfe2'.
       01  ID-TAB PIC X(15) VALUE 'tabell'.
       01  COMODI.
           05 SF-AZI   PIC XX.
           05 SF-TFE   PIC XX.
           05 SF-TF2   PIC XX.
           05 SF-TAB   PIC XX.
           05 MESS     PIC X(40) VALUE SPACE.
           05 SWINI    PIC 9     VALUE ZERO.
           05 FUN-PREC PIC X     VALUE ZERO.
           05 VKEY     PIC 9.
           05 VFLD     PIC 9.
           05 FLCK     PIC 9.
           05 FUN      PIC X.
           05 CAMPO    PIC X(20).
           05 VCAMPO   PIC X(20).
           05 KRIFER   PIC X(50).
       LINKAGE SECTION.
      *
      * Parametri locali di controllo interfaccia
      *
       01  RG-TF4-CTRL.
           05 RG-TF4-AZI   PIC 999.
           05 RG-TF4-FUN   PIC X.
           05 RG-TF4-CAMPO PIC X(20).
           05 RG-TF4-ST    PIC 9.
      *
      * Record di interfaccia
      *
       01  RG-TF4-REC.
           05 RG-TF4-TP1     PIC 99.
           05 RG-TF4-TP2     PIC 99.
           05 RG-TF4-TP3     PIC 99.
           05 RG-TF4-TP4     PIC 99.
           05 RG-TF4-TP5     PIC 99.
           05 RG-TF4-TP6     PIC 99.
           05 RG-TF4-TP9     PIC 99.
           05 RG-TF4-TIPORIT PIC 9.
           05 RG-TF4-CAUS    PIC XX.
           05 RG-TF4-TP1-D   PIC X(50).
           05 RG-TF4-TP2-D   PIC X(50).
           05 RG-TF4-TP3-D   PIC X(50).
           05 RG-TF4-TP4-D   PIC X(50).
           05 RG-TF4-TP5-D   PIC X(50).
           05 RG-TF4-TP6-D   PIC X(50).
           05 RG-TF4-TP9-D   PIC X(50).
           05 RG-TF4-CONAI-1 PIC X(100).
           05 RG-TF4-CONAI-2 PIC X(100).
           05 RG-TF4-CAUSALE-1 PIC X(100).
           05 RG-TF4-CAUSALE-2 PIC X(100).
      *
       01  RA-TF4-AGG.
           05 RA-TF4-AZI-D  PIC X(36).
      *
       01  IF-MESS    PIC X(204).
       PROCEDURE DIVISION USING RG-TF4-CTRL
                                RG-TF4-REC
                                RA-TF4-AGG
                                IF-MESS.
           COPY 'declxer1'.
           COPY 'dclazi'.
           COPY 'dcltfe'.
           COPY 'dcltf2'.
           COPY 'dcltab'.
           COPY 'declxer2'.
       INIZIO.
           COPY 'strcal'.
           MOVE ZERO  TO RG-TF4-ST.
           MOVE SPACE TO IF-MESS.
           IF RG-TF4-FUN = 'E' AND FUN-PREC = 'E' GO TO ESCI.
           IF SWINI = ZERO PERFORM INI-ELABORA THRU EX-INI-ELABORA.
           MOVE RG-TF4-FUN   TO FUN.
           MOVE RG-TF4-CAMPO TO CAMPO.
           MOVE ZERO TO FLCK.

           IF FUN = 'R' OR
                    'r' PERFORM MOVE-KEY
                        GO TO F-READ.
           IF FUN = 'U' GO TO F-UNLOCK.
           IF FUN = 'A' GO TO F-AGGIOR.
           IF FUN = 'D' GO TO F-DELETE.
           IF FUN = 'V' OR
                    'W' GO TO F-WALIDA.
           IF FUN = 'E' GO TO F-EXIT.
           MOVE 'VRGTF4: Funzione non ammessa' TO MESS.
           GO TO ERRIO.
      * - - - - - *
       F-READ.
           IF FUN = 'r' MOVE 1 TO FLCK.
           PERFORM READ-K THRU EX-READ-K.
           IF VKEY > ZERO
              PERFORM ERR-CINE
              GO TO WARNING.
           IF RG-TF4-ST = 7 GO TO FINE.
           PERFORM CARICA-RG THRU EX-CARICA-RG.
           PERFORM CARICA-RA THRU EX-CARICA-RA.
           GO TO FINE.
      * - - - - - *
       F-UNLOCK.
           IF FUN-PREC = 'U' GO TO FINE.
           UNLOCK TABFEL.
           GO TO F-READ.
      * - - - - - *
       F-AGGIOR.
           PERFORM CARICA-REC THRU EX-CARICA-REC.
           REWRITE RF-TFE INVALID
              PERFORM INVK-TFE
              GO TO ERRIO.
           REWRITE RF-TF2 INVALID
              PERFORM INVK-TFE
              GO TO ERRIO.
           UNLOCK TABFEL.
           GO TO FINE.
      * - - - - - *
       F-DELETE.
           PERFORM MOVE-KEY.
           MOVE 1 TO FLCK.
           PERFORM READ-K THRU EX-READ-K.
           IF VKEY > ZERO
              PERFORM INVK-TFE
              GO TO WARNING.
           IF RG-TF4-ST = 7 GO TO FINE.
           DELETE TABFEL INVALID
              PERFORM INVK-TFE
              GO TO ERRIO.
           DELETE TABFE2 INVALID
              PERFORM INVK-TFE
              GO TO ERRIO.
           UNLOCK TABFEL.
           GO TO FINE.
      * - - - - - *
       F-WALIDA.
           PERFORM V-DATI THRU EX-V-CHIAVE-DATI.
           IF VFLD = ZERO GO TO FINE.
           IF VFLD = 2 MOVE ZERO TO VFLD
                       GO TO WARNING.
           IF VFLD = 3 MOVE ZERO TO VFLD
                       GO TO QUESTION.
       F-W90.
           MOVE VCAMPO TO RG-TF4-CAMPO
           GO TO ERRFIELD.
      * - - - - - *
       F-EXIT.
           UNLOCK TABFEL.
           GO TO CHIUDI.
      * - - - - - *
       ERRIO.
           COPY 'errcal'.
           MOVE ERRIO-ST TO RG-TF4-ST.
           IF ERRIO-ST < 9 GO TO FINE.
       CHIUDI.
           CLOSE ANAAZI.
           CLOSE TABFEL.
           CLOSE TABFE2.
           CLOSE TABELL.
           MOVE ZERO TO SWINI.
       FINE.
           MOVE RG-TF4-FUN TO FUN-PREC.
       ESCI.
           IF ERRIO-ST > ZERO PERFORM ERRIO-MSG THRU EX-ERRIO-MSG
                              MOVE ERRIO-ST TO RG-TF4-ST.
           EXIT PROGRAM.
           COPY 'errmes'.
           COPY 'griazier'.
           COPY 'gritfeer'.
           COPY 'gritaber'.
           COPY 'gritf2er'.
           COPY 'grixxxer'.
      *------------------
      * inizializzazione di un ciclo di elaborazione 
      *    (ins/mod/vis/canc + validazioni + aggiornamenti)
       INI-ELABORA.
           OPEN INPUT ANAAZI.
           OPEN INPUT TABELL.
           OPEN I-O TABFEL.
           OPEN I-O TABFE2.
      *     
           MOVE RG-TF4-AZI TO KAZ-COD.
           READ ANAAZI INTO REKAZI INVALID PERFORM INVK-AZI
                                           GO TO ERRIO.
           IF SF-AZI = '9D' OR '9A' OR '35' MOVE RF-AZI TO REKAZI.
      *         
           PERFORM MOVE-KEY.
           READ TABFEL INVALID
                PERFORM SCRIVI THRU EX-SCRIVI.
      *
           MOVE RG-TF4-AZI TO KTF2-AZI.
           READ TABFE2 INVALID
                PERFORM SCRIVI-2 THRU EX-SCRIVI-2.
      *
           MOVE 1 TO SWINI.
       EX-INI-ELABORA.
           EXIT.
      *------------------
       MOVE-KEY.
           MOVE KAZ-COD TO KTFE-AZI. 
           MOVE KEYTFE   TO KRIFER.
      *------------------
       READ-K.
           MOVE ZERO TO VKEY.
           MOVE KRIFER TO KEYTFE.
           IF FLCK > ZERO GO TO RDK-10.
      *
           READ TABFEL INVALID
                MOVE 1 TO VKEY
                GO TO EX-READ-K.
           MOVE KEYTFE TO KEYTF2.
           READ TABFE2 INVALID
                PERFORM SCRIVI-2 THRU EX-SCRIVI-2.
           GO TO EX-READ-K.
      *
       RDK-10.
           READ TABFEL KEPT LOCK INVALID
                MOVE 1 TO VKEY
                GO TO EX-READ-K.
           MOVE KEYTFE TO KEYTF2.
           READ TABFE2 INVALID
                PERFORM SCRIVI-2 THRU EX-SCRIVI-2.
           IF SF-TFE > ZERO MOVE 7 TO RG-TF4-ST.
      *
       EX-READ-K.
           EXIT.
      *------------------
       CARICA-REC.
           MOVE RG-TF4-AZI     TO KTFE-AZI KTF2-AZI.
      *
           MOVE RG-TF4-TP1 TO TFE-TP(1).
           MOVE RG-TF4-TP2 TO TFE-TP(2).
           MOVE RG-TF4-TP3 TO TFE-TP(3).
           MOVE RG-TF4-TP4 TO TFE-TP(4).
           MOVE RG-TF4-TP5 TO TFE-TP(5).
           MOVE RG-TF4-TP6 TO TFE-TP(6).
           MOVE RG-TF4-TP9 TO TFE-TP(9).
           MOVE RG-TF4-TIPORIT  TO TFE-TIPORIT.
           MOVE RG-TF4-CAUS     TO TFE-CAUS.
           MOVE RG-TF4-CONAI-1  TO TF2-CONAI-1.
           MOVE RG-TF4-CONAI-2  TO TF2-CONAI-2.
           MOVE RG-TF4-CAUSALE-1  TO TF2-CAUSALE-1.
           MOVE RG-TF4-CAUSALE-2  TO TF2-CAUSALE-2.
       EX-CARICA-REC.
           EXIT.
      *------------------
       CARICA-RG.
           MOVE TFE-TP(1) TO RG-TF4-TP1.
           MOVE TFE-TP(2) TO RG-TF4-TP2.
           MOVE TFE-TP(3) TO RG-TF4-TP3.
           MOVE TFE-TP(4) TO RG-TF4-TP4.
           MOVE TFE-TP(5) TO RG-TF4-TP5.
           MOVE TFE-TP(6) TO RG-TF4-TP6.
           MOVE TFE-TP(9) TO RG-TF4-TP9.
           MOVE TFE-TIPORIT  TO RG-TF4-TIPORIT.
           MOVE TFE-CAUS     TO RG-TF4-CAUS.
           MOVE TF2-CONAI-1  TO RG-TF4-CONAI-1.
           MOVE TF2-CONAI-2  TO RG-TF4-CONAI-2.
           MOVE TF2-CAUSALE-1  TO RG-TF4-CAUSALE-1.
           MOVE TF2-CAUSALE-2  TO RG-TF4-CAUSALE-2.
      *
           MOVE RG-TF4-TP1 TO KTB-COD.
           MOVE 50         TO KTB-TIP.
           READ TABELL INTO REKT50 INVALID
                MOVE SPACE TO T50-DESCR.
           MOVE T50-DESCR TO RG-TF4-TP1-D.
      *
           MOVE RG-TF4-TP2 TO KTB-COD.
           MOVE 50         TO KTB-TIP.
           READ TABELL INTO REKT50 INVALID
                MOVE SPACE TO T50-DESCR.
           MOVE T50-DESCR TO RG-TF4-TP2-D.
      *
           MOVE RG-TF4-TP3 TO KTB-COD.
           MOVE 50         TO KTB-TIP.
           READ TABELL INTO REKT50 INVALID
                MOVE SPACE TO T50-DESCR.
           MOVE T50-DESCR TO RG-TF4-TP3-D.
      *
           MOVE RG-TF4-TP4 TO KTB-COD.
           MOVE 50         TO KTB-TIP.
           READ TABELL INTO REKT50 INVALID
                MOVE SPACE TO T50-DESCR.
           MOVE T50-DESCR TO RG-TF4-TP4-D.
      *
           MOVE RG-TF4-TP5 TO KTB-COD.
           MOVE 50         TO KTB-TIP.
           READ TABELL INTO REKT50 INVALID
                MOVE SPACE TO T50-DESCR.
           MOVE T50-DESCR TO RG-TF4-TP5-D.
      *
           MOVE RG-TF4-TP6 TO KTB-COD.
           MOVE 50         TO KTB-TIP.
           READ TABELL INTO REKT50 INVALID
                MOVE SPACE TO T50-DESCR.
           MOVE T50-DESCR TO RG-TF4-TP6-D.
      *
           MOVE RG-TF4-TP9 TO KTB-COD.
           MOVE 50         TO KTB-TIP.
           READ TABELL INTO REKT50 INVALID
                MOVE SPACE TO T50-DESCR.
           MOVE T50-DESCR TO RG-TF4-TP9-D.
       EX-CARICA-RG.
           EXIT.
      *------------------
       CARICA-RA.
           MOVE AZRGSOC TO RA-TF4-AZI-D.
       EX-CARICA-RA.
           EXIT.
      *------------------
      * validazione dei campi non chiave (NB: di RG-T30-REC)
       V-DATI.
           MOVE ZERO TO VFLD.
      *
       V-TIPPER.
           MOVE 'TF4-TIPPER' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-TIPPER.
       E-TIPPER.
      *
       V-TP1.
           MOVE 'TF4-TP1' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-TP1.
           IF RG-TF4-TP1 = ZERO 
              MOVE SPACE TO RG-TF4-TP1-D
              GO TO E-TP1.
           MOVE RG-TF4-TP1 TO KTB-COD.
           MOVE 50         TO KTB-TIP.
           READ TABELL INTO REKT50 INVALID
              PERFORM ERR-CINE
              GO TO V-ERROR.
           MOVE T50-DESCR TO RG-TF4-TP1-D.
      *
       E-TP1.
      *
       V-TP2.
           MOVE 'TF4-TP2' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-TP2.
           IF RG-TF4-TP2 = ZERO 
              MOVE SPACE TO RG-TF4-TP2-D
              GO TO E-TP2.
           MOVE RG-TF4-TP2 TO KTB-COD.
           MOVE 50         TO KTB-TIP.
           READ TABELL INTO REKT50 INVALID
              PERFORM ERR-CINE
              GO TO V-ERROR.
           MOVE T50-DESCR TO RG-TF4-TP2-D.
      *
       E-TP2.
      *
       V-TP3.
           MOVE 'TF4-TP3' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-TP3.
           IF RG-TF4-TP3 = ZERO 
              MOVE SPACE TO RG-TF4-TP3-D
              GO TO E-TP3.
           MOVE RG-TF4-TP3 TO KTB-COD.
           MOVE 50         TO KTB-TIP.
           READ TABELL INTO REKT50 INVALID
              PERFORM ERR-CINE
              GO TO V-ERROR.
           MOVE T50-DESCR TO RG-TF4-TP3-D.
      *
       E-TP3.
      *
       V-TP4.
           MOVE 'TF4-TP4' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-TP4.
           IF RG-TF4-TP4 = ZERO 
              MOVE SPACE TO RG-TF4-TP4-D
              GO TO E-TP4.
           MOVE RG-TF4-TP4 TO KTB-COD.
           MOVE 50         TO KTB-TIP.
           READ TABELL INTO REKT50 INVALID
              PERFORM ERR-CINE
              GO TO V-ERROR.
           MOVE T50-DESCR TO RG-TF4-TP4-D.
      *
       E-TP4.
      *
       V-TP5.
           MOVE 'TF4-TP5' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-TP5.
           IF RG-TF4-TP5 = ZERO 
              MOVE SPACE TO RG-TF4-TP5-D
              GO TO E-TP5.
           MOVE RG-TF4-TP5 TO KTB-COD.
           MOVE 50         TO KTB-TIP.
           READ TABELL INTO REKT50 INVALID
              PERFORM ERR-CINE
              GO TO V-ERROR.
           MOVE T50-DESCR TO RG-TF4-TP5-D.
      *
       E-TP5.
      *
       V-TP6.
           MOVE 'TF4-TP6' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-TP6.
           IF RG-TF4-TP6 = ZERO 
              MOVE SPACE TO RG-TF4-TP6-D
              GO TO E-TP6.
           MOVE RG-TF4-TP6 TO KTB-COD.
           MOVE 50         TO KTB-TIP.
           READ TABELL INTO REKT50 INVALID
              PERFORM ERR-CINE
              GO TO V-ERROR.
           MOVE T50-DESCR TO RG-TF4-TP6-D.
      *
       E-TP6.
      *
       V-TP9.
           MOVE 'TF4-TP9' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-TP9.
           IF RG-TF4-TP9 = ZERO 
              MOVE SPACE TO RG-TF4-TP9-D
              GO TO E-TP9.
           MOVE RG-TF4-TP9 TO KTB-COD.
           MOVE 50         TO KTB-TIP.
           READ TABELL INTO REKT50 INVALID
              PERFORM ERR-CINE
              GO TO V-ERROR.
           MOVE T50-DESCR TO RG-TF4-TP9-D.
      *
       E-TP9.
      *
       V-CONAI-2.
           MOVE 'TF4-CONAI-2' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-CONAI-2.
           IF RG-TF4-CONAI-1 = SPACE AND RG-TF4-CONAI-2 NOT = SPACE
              PERFORM ERR-DINC
              GO TO V-ERROR.
      *
       E-CONAI-2.
      *
       V-CAUSALE-2.
           MOVE 'TF4-CAUSALE-2' TO VCAMPO.
           IF FUN = 'V' AND VCAMPO NOT = CAMPO GO TO E-CAUSALE-2.
           IF RG-TF4-CAUSALE-1 = SPACE AND RG-TF4-CAUSALE-2 NOT = SPACE
              PERFORM ERR-DINC
              GO TO V-ERROR.
      *
       E-CAUSALE-2.
      *
           GO TO EX-V-CHIAVE-DATI.
       V-ERROR.
           MOVE 1 TO VFLD.
           GO TO EX-V-CHIAVE-DATI.
       V-WARNING.
           MOVE 2 TO VFLD.
           GO TO EX-V-CHIAVE-DATI.
       V-QUESTION.
           MOVE 3 TO VFLD.
       EX-V-CHIAVE-DATI.
           EXIT.
      *------------------
       SCRIVI.
           MOVE ZERO  TO RF-TFE.
           PERFORM MOVE-KEY.
           MOVE SPACE TO TFE-CAUS.
           WRITE RF-TFE INVALID PERFORM INVK-TFE
                                        GO TO ERRIO.
       EX-SCRIVI.
           EXIT.
      *------------------
       SCRIVI-2.
           MOVE ZERO  TO RF-TF2.
           MOVE RG-TF4-AZI TO KTF2-AZI.
           MOVE 'CONTRIBUTO CONAI ASSOLTO OVE DOVUTO' TO TF2-CONAI-1.
           MOVE SPACE                                 TO TF2-CONAI-2.
           STRING 'Operazione non imponibile IVA ai sensi'
                   ' art. 8, c. 1, lett. c), DPR 633/1972'
                   DELIMITED SIZE INTO TF2-CAUSALE-1.
           MOVE SPACE                                 TO TF2-CAUSALE-2.
           WRITE RF-TF2 INVALID PERFORM INVK-TF2
                                        GO TO ERRIO.
       EX-SCRIVI-2.
           EXIT.
      *------------------
