       IDENTIFICATION DIVISION.
       PROGRAM-ID. VRCDSPS.
      *
      *    Routine per acquisizione codice fiscale/piva/nazione
      *
       ENVIRONMENT DIVISION.
       CONFIGURATION SECTION.
       SPECIAL-NAMES. DECIMAL-POINT IS COMMA.
       INPUT-OUTPUT SECTION.
       FILE-CONTROL.
           COPY 'griazisl'.
           COPY 'gritabsl'.
           COPY 'griclfsl'.
           COPY 'griacfsl'.
           COPY 'grispssl'.
           COPY 'gribktsl'.
       DATA DIVISION.
       FILE SECTION.
           COPY 'griazi'.
           COPY 'gritab'.
           COPY 'griclf'.
           COPY 'griacf'.
           COPY 'grisps'.
           COPY 'gribkt'.
       WORKING-STORAGE SECTION.
           COPY 'grirel-72'.    
           COPY 'gritabrk'.
           COPY 'griclfrk'.
           COPY 'gribktrk'.
           COPY 'parzf'.
           COPY 'parag'.
           COPY 'prfisc'.
           COPY 'prpiva'.
           COPY 'parul'.
       01  ID-AZI PIC X(15) VALUE 'anaazi'.
       01  ID-TAB PIC X(15) VALUE 'tabell'.
       01  ID-CLF PIC X(15) VALUE 'anaclf'.
       01  ID-ACF PIC X(15) VALUE 'appclf'.
       01  ID-SPS PIC X(15) VALUE 'spesog'.
       01  ID-BKT PIC X(15) VALUE 'blktab'.
       01  COMODI.
           05 SF-AZI   PIC XX.
           05 SF-TAB   PIC XX.
           05 SF-CLF  PIC XX.
           05 SF-ACF  PIC XX.
           05 SF-SPS  PIC XX.
           05 SF-BKT  PIC XX.
       01  AREE.
           05 MESS    PIC X(40).
           05 MCLI     PIC 9(2).
           05 MFOR     PIC 9(2).
           05 SAVPIVA  PIC X(20).
           05 SAVCFISC PIC X(20).
           05 CONTROLLOK PIC 9.
           05 CODICE.
              10 MAS PIC 99.
              10 COD PIC 9(5).
      *
       LINKAGE SECTION.
           COPY 'pardsps'.
       PROCEDURE DIVISION USING PARDSPS.
           COPY 'declxer1'.
           COPY 'dclazi'.
           COPY 'dcltab'.
           COPY 'dclclf'.
           COPY 'dclacf'.
           COPY 'dclsps'.
           COPY 'dclbkt'.
           COPY 'declxer2'.
       INIZIO.
           COPY 'strcal'.
      *
      *    MOVE ZERO TO PDSPS-ST.
           MOVE SPACE TO PDSPS-CFISC.
           MOVE SPACE TO PDSPS-PIVA.
           MOVE SPACE TO PDSPS-NAZ.
           MOVE ZERO  TO PDSPS-CEE.
      *
           IF PDSPS-ST NOT = 7 AND
              PDSPS-ST NOT = 8
              OPEN INPUT TABELL ANAAZI ANACLF APPCLF SPESOG BLKTAB
              IF PDSPS-ST = 6
                 GO TO FINE
              END-IF
           ELSE
              IF PDSPS-ST = 8
                 GO TO FINE.
      *
           MOVE 1 TO KTB-COD KTB-TIP.
           READ TABELL INTO REKTAB INVALID GO TO FINE.
           IF SF-TAB = '9D' OR '9A' OR '35' MOVE RF-TAB TO REKTAB.
           MOVE T01-MCLI TO MCLI.
           MOVE T01-MFOR TO MFOR.
      *
           MOVE SPACE TO SAVCFISC SAVPIVA.
      *
           MOVE ZERO TO CODICE.
           IF PDSPS-CFGO = 'C'
              MOVE MCLI TO MAS
           ELSE
              MOVE MFOR TO MAS.
           MOVE PDSPS-SOG TO COD.
      *
           MOVE PDSPS-AZI TO KCF-AZI.
           MOVE CODICE    TO KCF-COD.
           READ ANACLF INTO REKCLF INVALID KEY
                                   GO TO FINE-LETTURA.
      *
           IF CLF-MS = MFOR
              IF CLF-13IVA = 3
                 MOVE 'OO' TO PDSPS-NAZ
                 MOVE '99999999999' TO PDSPS-PIVA
                 GO TO FINE-LETTURA.
      *
           MOVE KCF-AZI TO KACF-AZI.
           MOVE KCF-COD TO KACF-COD.
           READ APPCLF INVALID MOVE SPACE TO ACF-NAZIO.
      *
           MOVE PDSPS-AZI TO KSPS-AZI.
           MOVE CODICE    TO KSPS-COD.
           READ SPESOG INVALID KEY 
                       MOVE SPACE TO REKSPS
                       MOVE 1 TO SPS-FLGBSE
                       MOVE ZERO TO SPS-STAB-CAP
                       MOVE HIGH-VALUE TO SPS-PIVA SPS-CFISC.
      *
           IF CLF-PIVA NOT = ZERO
              MOVE CLF-PIVA TO SAVPIVA.
           IF CLF-PAE = 'IT' AND CLF-IVE(1:11) IS NUMERIC AND
              CLF-IVE(12:) = SPACE
              MOVE CLF-IVE(1:11) TO SAVPIVA.
           MOVE CLF-CFISC TO SAVCFISC.
           IF CLF-13IVA = 4
              IF CLF-PAE NOT = SPACE AND
                 CLF-PAE NOT = 'IT' AND
                 CLF-PAE IS NOT NUMERIC
                 MOVE CLF-CFISC TO COMFISC
                 CALL 'rfisc' USING PARFISC
                 IF RISPFISC NOT = ZERO
                    MOVE SPACE     TO SAVCFISC
                    MOVE CLF-IVE   TO SAVPIVA. 
      * cerca nazione
           IF SPS-NAZIONE NOT = SPACE
              MOVE 01          TO BKT01-TIP
              MOVE SPS-NAZIONE TO BKT01-COD
              MOVE BKT01-KEYID  TO KEYBKT
              READ BLKTAB INTO REKBKT INVALID
                   MOVE SPACE TO BKT01-ISOALFA
                   MOVE ZERO  TO BKT01-CEE
              END-READ
              MOVE BKT01-ISOALFA TO PDSPS-NAZ
              MOVE BKT01-CEE     TO PDSPS-CEE
           ELSE
              MOVE 01        TO BKT01-TIP
              MOVE ACF-NAZIO TO BKT01-COD
              MOVE BKT01-KEYID  TO KEYBKT
              READ BLKTAB INTO REKBKT INVALID
                   MOVE SPACE TO BKT01-ISOALFA
                   MOVE ZERO  TO BKT01-CEE
              END-READ
              MOVE BKT01-ISOALFA TO PDSPS-NAZ
              MOVE BKT01-CEE     TO PDSPS-CEE. 
      * forza partita iva
           IF SPS-PIVA NOT = HIGH-VALUE
              IF SPS-PIVA(1:11) NOT = ZERO
                 MOVE SPS-PIVA TO SAVPIVA.
      * forza codice fiscale
           IF SPS-CFISC NOT = HIGH-VALUE
              MOVE SPS-CFISC TO SAVCFISC.
      *
           MOVE 9 TO CONTROLLOK.
           IF CLF-13IVA = ZERO
              GO TO NOITA.
           IF CLF-MS = MFOR
              IF CLF-13IVA = 3
                 GO TO NOITA.
      * verifica se partita iva/codice fiscale sono italiani
           PERFORM CONTROLLO-PIVA THRU EX-CONTROLLO-PIVA.
           IF CONTROLLOK = ZERO AND PDSPS-NAZ = SPACE
              MOVE 'IT' TO PDSPS-NAZ.
           IF PDSPS-ST NOT = 7
              MOVE CONTROLLOK TO PDSPS-ST.
           IF PDSPS-NAZ NOT = 'IT'
              MOVE SAVPIVA TO PDSPS-PIVA 
              GO TO NOPIVA.
       NOITA.
      *
           IF CLF-13IVA = 1 OR CLF-13IVA = 2
              IF SAVPIVA = SPACE OR SAVPIVA(1:11) = ZERO
                 IF SAVCFISC(1:11) IS NOT NUMERIC OR
                    SAVCFISC(12:) NOT = SPACE
                    GO TO NOPIVA.
      *
           IF PDSPS-CFGO = 'C'
              IF SAVCFISC(1:11) IS NUMERIC AND
                 SAVCFISC(12:) = SPACE
                 IF SAVCFISC(1:1) = '8' OR
                    SAVCFISC(1:1) = '9'
                    IF SAVPIVA       = SPACE OR
                       SAVPIVA(1:11) = ZERO  OR
                       SAVPIVA = SAVCFISC(1:11)
                       GO TO NOPIVA.
      *
           IF PDSPS-CFGO = 'C'
              IF CLF-13IVA = ZERO 
                 IF PDSPS-NAZ = 'IT'
                    IF SAVCFISC(1:11) IS NOT NUMERIC
                       GO TO NOPIVA.
      *
           IF CLF-13IVA = 4
              IF SAVPIVA = SPACE OR SAVPIVA(1:11) = ZERO
                 IF CLF-IVE = ZERO OR CLF-IVE = SPACE
                    GO TO NOPIVA.
      *
           IF SAVPIVA(1:11) NOT = ZERO AND
              SAVPIVA NOT = SPACE
              MOVE SAVPIVA TO PDSPS-PIVA 
           ELSE
              IF CLF-13IVA = 4       AND
                 CLF-PAE NOT = 'IT'  AND
                 CLF-PAE NOT = SPACE AND
                 CLF-PAE NOT NUMERIC AND
                 PDSPS-NAZ NOT = 'IT'
                 MOVE CLF-IVE TO PDSPS-PIVA
              ELSE
                 IF CONTROLLOK = 1
                    MOVE SAVPIVA TO PDSPS-PIVA
                 ELSE
                    IF CLF-MS = MFOR OR
                       CONTROLLOK NOT = ZERO
                       IF CONTROLLOK = 2
                          MOVE SAVCFISC(1:11) TO PDSPS-PIVA
                       ELSE
                          MOVE SAVCFISC TO PDSPS-PIVA.
      *
           GO TO FINE-LETTURA.
       NOPIVA.
      *
           IF SAVCFISC NOT = ZERO
               MOVE SAVCFISC TO PDSPS-CFISC.
      *
       FINE-LETTURA.
      *
           MOVE PDSPS-NAZ TO UL-STR.
           MOVE 'U' TO UL-FUN.
           CALL 'ruplo' USING PARUL.
           MOVE UL-STR TO PDSPS-NAZ.
      *
       ERRIO.
      *    COPY 'errcal'.
       FINE.
           IF PDSPS-ST NOT = 6 AND
              PDSPS-ST NOT = 7
              CLOSE TABELL ANAAZI ANACLF APPCLF SPESOG BLKTAB.
       ESCI.
           EXIT PROGRAM.
           COPY 'griazier'.
           COPY 'gritaber'.
           COPY 'griclfer'.
           COPY 'griacfer'.
           COPY 'grispser'.
           COPY 'gribkter'.
           COPY 'grixxxer'.
           EXIT.
      *------------------
       CONTROLLO-PIVA.
           IF SAVCFISC NOT = SPACE
              IF CLF-13IVA = 4
                 IF CLF-PAE NOT = SPACE    AND
                    CLF-PAE NOT = 'IT'     AND
                    CLF-PAE IS NOT NUMERIC 
                    MOVE SAVCFISC TO COMFISC
                    CALL 'rfisc' USING PARFISC
                    IF RISPFISC = ZERO
                       MOVE COMFISC TO PDSPS-CFISC
                       MOVE ZERO TO CONTROLLOK
                       GO TO EX-CONTROLLO-PIVA
                    ELSE
                       MOVE 4 TO CONTROLLOK.
      *
           IF SAVPIVA = SPACE GO TO NOIVA.
           IF SAVPIVA(1:11) = ZERO AND
              SAVPIVA(12:)  = SPACE GO TO NOIVA.
           IF SAVPIVA(1:11) NOT NUMERIC OR
              SAVPIVA(12:) NOT = SPACE GO TO NOIVA.
      *
           MOVE SAVPIVA(1:11) TO CODPIVA.
           CALL 'rpiva' USING PARPIVA.
           IF RISPIVA NOT = ZERO
              MOVE 1 TO CONTROLLOK
              GO TO EX-CONTROLLO-PIVA
           ELSE
              MOVE ZERO TO CONTROLLOK.
           IF CLF-PAE = 'IT'
              GO TO EX-CONTROLLO-PIVA.
      *
       NOIVA.
           IF SAVCFISC = SPACE GO TO EX-CONTROLLO-PIVA.
      * 
           IF SAVCFISC(1:11) IS NUMERIC AND
              SAVCFISC(12:) = SPACE
              MOVE SAVCFISC(1:11) TO CODPIVA
              CALL 'rpiva' USING PARPIVA
              IF RISPIVA NOT = ZERO
                 MOVE 2 TO CONTROLLOK
              ELSE
                 MOVE SAVCFISC(1:11) TO PDSPS-CFISC
                 MOVE ZERO TO CONTROLLOK
              END-IF
           ELSE
              MOVE SAVCFISC TO COMFISC
              CALL 'rfisc' USING PARFISC
              IF RISPFISC NOT = ZERO
                 MOVE 3 TO CONTROLLOK
              ELSE
                 MOVE COMFISC TO PDSPS-CFISC
                 MOVE ZERO TO CONTROLLOK.
       EX-CONTROLLO-PIVA.
           EXIT.
      *------------------
